/*==============================================================================
// 
//	File: InterpolationPIE.h
//
//
//	Argus Numerical Environments - Plug In Extension, Release 1.0
// 
//	Copyright  1996 Argus Holdings Ltd.  All rights reserved.
//
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Argus Holdings Ltd..
// The copyright notice above does not evidence any
// actual or intended publication of such source code
//==============================================================================*/

#ifndef _InterpolationPIE_H_
#define _InterpolationPIE_H_

#ifndef _ANEPIE_H_
#include "ANEPIE.h"
#endif /* _ANEPIE_H_ */

#define INTERPOLATION_PIE_VERSION 1

#ifdef __cplusplus
extern "C" {
#endif
typedef void (*PIEInterpolationPreProc)(ANE_PTR aneHandle, ANE_PTR* rPIEHandle, ANE_INT32 numPoints, ANE_DOUBLE* xCoords, ANE_DOUBLE* yCoords, ANE_DOUBLE* values);

typedef void (*PIEInterpolationEvalProc)(ANE_PTR aneHandle, ANE_PTR pieHandle, ANE_DOUBLE x, ANE_DOUBLE y, ANE_DOUBLE* rResult);

typedef void (*PIEInterpolationClean)(ANE_PTR aneHandle, ANE_PTR pieHandle);

#ifdef __cplusplus
}
#endif



enum EInterpolationFlags {kInterpolationIncremental = 0x1,
			kInterpolationCallPre = 0x2,
			kInterpolationShouldClean = 0x4};

struct InterpolationPIEDesc
{
		ANE_INT32		version;
		ANE_STR			name;
		enum EInterpolationFlags	interpolationFlags;
		PIEInterpolationPreProc		preProc;
		PIEInterpolationEvalProc	evalProc;
		PIEInterpolationClean		cleanProc;
		ANE_STR						neededProject;
		
}; /* InterpolationPIEDesc */




#endif /* _InterpolationPIE_H_ */

/*==============================================================================
//	End File: InterpolationPIE.h
//==============================================================================*/
