// Pane7.cpp : implementation file
//

#include "stdafx.h"
#include "sutra.h"
#include "Pane7.h"
#include "TabbedDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPane7 property page

static UINT enableOnEnergySimulation[] = { IDC_CS, IDC_SIGMAS};
static UINT disableOnSaturatedEnergySimulation[] = { IDC_ADSMOD};

IMPLEMENT_DYNCREATE(CPane7, CBasePropertyPage)

CPane7::CPane7() : CBasePropertyPage(CPane7::IDD)
{
	//{{AFX_DATA_INIT(CPane7)
	m_ADSMOD = _T("");
	m_CHI1 = 0.0;
	m_CHI2 = 0.0;
	m_COMPMA = 0.0;
	m_CS = 0.0;
	m_RHOS = 0.0;
	m_SIGMAS = 0.0;
	//}}AFX_DATA_INIT
}

CPane7::~CPane7()
{
}

void CPane7::DoDataExchange(CDataExchange* pDX)
{
	CBasePropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPane7)
	DDX_Control(pDX, IDC_CHI2LABEL1, m_CHI2Label1);
	DDX_Control(pDX, IDC_CHI2LABEL, m_CHI2Label);
	DDX_Control(pDX, IDC_CHI1LABEL1, m_CHI1Label1);
	DDX_Control(pDX, IDC_CHI1LABEL, m_CHI1Label);
	DDX_Control(pDX, IDC_SIGMAS, m_CSIGMAEdit);
	DDX_Control(pDX, IDC_CS, m_CSEdit);
	DDX_Control(pDX, IDC_CHI2, m_CHI2Edit);
	DDX_Control(pDX, IDC_CHI1, m_CHI1Edit);
	DDX_Control(pDX, IDC_ADSMOD, m_ADSMODCombo);
	DDX_CBString(pDX, IDC_ADSMOD, m_ADSMOD);
	DDX_Text(pDX, IDC_CHI1, m_CHI1);
	DDX_Text(pDX, IDC_CHI2, m_CHI2);
	DDX_Text(pDX, IDC_COMPMA, m_COMPMA);
	DDX_Text(pDX, IDC_CS, m_CS);
	DDX_Text(pDX, IDC_RHOS, m_RHOS);
	DDX_Text(pDX, IDC_SIGMAS, m_SIGMAS);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPane7, CBasePropertyPage)
	//{{AFX_MSG_MAP(CPane7)
	ON_CBN_SELENDOK(IDC_ADSMOD, OnSelendokAdsmod)
	ON_CBN_SELCHANGE(IDC_ADSMOD, OnSelchangeAdsmod)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPane7 message handlers

void CPane7::ReturnValues(SUTRAProjectInfo &info)
{
	info.ADSMOD = (m_ADSMOD+"         ").Left(10);
	info.CHI1 = m_CHI1;
	info.CHI2 = m_CHI2;
	info.COMPMA = m_COMPMA;
	info.CS = m_CS;
	info.RHOS = m_RHOS;
	info.SIGMAS = m_SIGMAS;
}

void CPane7::GetValues(SUTRAProjectInfo &info)
{
	m_ADSMOD = (info.ADSMOD+"         ").Left(10);
	m_CHI1 = info.CHI1;
	m_CHI2 = info.CHI2;
	m_COMPMA = info.COMPMA;
	m_CS = info.CS;
	m_RHOS = info.RHOS;
	m_SIGMAS = info.SIGMAS;

	m_SaturatedEnergySimulation = (!info.defaultSetting &&  info.transportConditions != SUTRAProjectInfo::kENERGY && info.flowConditions == SUTRAProjectInfo::kSATURATED);

}

void CPane7::OnSelendokAdsmod() 
{
//	switch (m_ADSMODCombo.GetCurSel())
//	{
//		0:
//			m_CHI1Edit.
}

BOOL CPane7::OnSetActive() 
{
		CTabbedDialog* tabbedDialog = (CTabbedDialog*)this->GetParent();

	BOOL energySimulation = tabbedDialog->m_EnergySimulation;

	this->EnableControls(enableOnEnergySimulation, SIZEOF_ARRAY(enableOnEnergySimulation), energySimulation);
	this->EnableControls(disableOnSaturatedEnergySimulation, SIZEOF_ARRAY(disableOnSaturatedEnergySimulation), !energySimulation/*m_SaturatedEnergySimulation*/);

	this->OnSelchangeAdsmod(); // set ADSMOD correctly

	return CBasePropertyPage::OnSetActive();
}

void CPane7::OnSelchangeAdsmod() 
{
	int adsmodIndex = m_ADSMODCombo.GetCurSel( );

	// 0 == 	NONE      
	// 1 == LINEAR    
	// 2 == LANGMUIR  
  // 3 == FREUNDLICH
	
	BOOL enableChi1 = adsmodIndex > 0;
	BOOL enableChi2 = adsmodIndex > 1;

	m_CHI1Edit.EnableWindow(enableChi1);

	if (enableChi1)
	{
		 m_CHI1Edit.ShowWindow(SW_SHOW);
		 m_CHI1Label.ShowWindow(SW_SHOW);
		 m_CHI1Label1.ShowWindow(SW_SHOW);
	}
	else
	{
		 m_CHI1Edit.ShowWindow(SW_HIDE);
		 m_CHI1Label.ShowWindow(SW_HIDE);
		 m_CHI1Label1.ShowWindow(SW_HIDE);
	}

	if (enableChi2)
	{
		 m_CHI2Edit.ShowWindow(SW_SHOW);
		 m_CHI2Label.ShowWindow(SW_SHOW);
		 m_CHI2Label1.ShowWindow(SW_SHOW);
	}
	else
	{
		 m_CHI2Edit.ShowWindow(SW_HIDE);
		 m_CHI2Label.ShowWindow(SW_HIDE);
		 m_CHI2Label1.ShowWindow(SW_HIDE);
	}
}
