// Pane8.cpp : implementation file
//

#include "stdafx.h"
#include "sutra.h"
#include "Pane8.h"
#include "TabbedDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPane8 property page

IMPLEMENT_DYNCREATE(CPane8, CBasePropertyPage)

CPane8::CPane8() : CBasePropertyPage(CPane8::IDD)
{
	//{{AFX_DATA_INIT(CPane8)
	m_GRAVX = 0.0;
	m_GRAVY = 0.0;
	m_PRODF0 = 0.0;
	m_PRODF1 = 0.0;
	m_PRODS0 = 0.0;
	m_PRODS1 = 0.0;
	//}}AFX_DATA_INIT
}

CPane8::~CPane8()
{
}

void CPane8::DoDataExchange(CDataExchange* pDX)
{
	CBasePropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPane8)
	DDX_Control(pDX, IDC_GRAVY, m_GRAVYEdit);
	DDX_Control(pDX, IDC_GRAVX, m_GRAVXEdit);
	DDX_Control(pDX, IDC_PRODS1, m_PRODS1Edit);
	DDX_Control(pDX, IDC_PRODF1, m_PRODF1Edit);
	DDX_Text(pDX, IDC_GRAVX, m_GRAVX);
	DDX_Text(pDX, IDC_GRAVY, m_GRAVY);
	DDX_Text(pDX, IDC_PRODF0, m_PRODF0);
	DDX_Text(pDX, IDC_PRODF1, m_PRODF1);
	DDX_Text(pDX, IDC_PRODS0, m_PRODS0);
	DDX_Text(pDX, IDC_PRODS1, m_PRODS1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPane8, CBasePropertyPage)
	//{{AFX_MSG_MAP(CPane8)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPane8 message handlers

static UINT staticTextToModify[] = { IDC_PRODUCTION_TITLE};

void CPane8::ReturnValues(SUTRAProjectInfo &info)
{
	info.GRAVX = m_GRAVX;
	info.GRAVY = m_GRAVY;
	info.PRODF0 = m_PRODF0;
	info.PRODF1 = m_PRODF1;
	info.PRODS0 = m_PRODS0;
	info.PRODS1 = m_PRODS1;
}

void CPane8::GetValues(SUTRAProjectInfo &info)
{
	m_GRAVX = info.GRAVX;
	m_GRAVY = info.GRAVY;
	m_PRODF0 = info.PRODF0;
	m_PRODF1 = info.PRODF1;
	m_PRODS0 = info.PRODS0;
	m_PRODS1 = info.PRODS1;

	m_ArealModel = (!info.defaultSetting && info.orientation == SUTRAProjectInfo::kAREAL);
	m_SoluteConstModel = (!info.defaultSetting && info.transportConditions == SUTRAProjectInfo::kSOLUTE_CONST);
}

BOOL CPane8::OnSetActive() 
{
	CTabbedDialog* tabbedDialog = (CTabbedDialog*)this->GetParent();

	BOOL energySimulation = tabbedDialog->m_EnergySimulation;

	m_PRODF1Edit.EnableWindow(!energySimulation);
	m_PRODS1Edit.EnableWindow(!energySimulation);

	if (m_ArealModel || m_SoluteConstModel)
	{
		m_GRAVXEdit.EnableWindow(FALSE);
		m_GRAVYEdit.EnableWindow(FALSE);
	}

	this->ReplaceIni(staticTextToModify, SIZEOF_ARRAY(staticTextToModify));

	return CBasePropertyPage::OnSetActive();
}
